CREATE OR REPLACE VIEW "AROPS"."SPERMISSION_V" ("ID", "ACCOUNT_GRANT", "ASSIGNABLE", "AUTHORITATIVE", "BOUND_BY_ID", "BOUNDABLE", "COST", "DELETED", "DESCRIPTION", "DISPLAY_NAME", "DRIVER_ID", "EFFECTIVE", "EXCLUDE_FROM_CATALOG", "IS_CURATED", "LOGICAL_ID", "MERGED", "NAME", "NOT_REVIEWABLE", "OWNER", "PERMISSION_ID", "PROV_ATTRIBUTE", "PROV_BY_UNIQUE_PERMISSION_ID", "PROV_NATIVE_VALUE", "PROV_UNIQUE_DRIVER_ID", "PROVISIONABLE", "RISK", "TYPE", "UNIQUE_BOUND_BY_ID", "UNIQUE_PERMISSION_ID", "VALUE", "VALUE_TYPE", "APPLICATION", "BASE_APPLICATION", "COLLECTED_ENTITY", "DATA_COLLECTION", "EFFECTIVE_ENTITY", "SVERSION", "AUTO_GENERATED", "PROV_UNIQUE_PERMISSION_ID", "AUTHORIZED_BY") AS 
  SELECT DISTINCT spermission.id,
    spermission.account_grant,
    spermission.assignable,
    spermission.authoritative,
    to_char(spermission.bound_by_id) bound_by_id,
    spermission.boundable,
    spermission.cost,
    spermission.deleted,
    spermission.description,
    spermission.display_name,
    spermission.driver_id,
    spermission.effective,
    spermission.exclude_from_catalog,
    spermission.is_curated,
    spermission.logical_id,
    spermission.merged,
    spermission.name,
    spermission.not_reviewable,
    spermission.owner,
    to_char(spermission.permission_id) permission_id,
    spermission.prov_attribute,
    spermission.prov_by_unique_permission_id,
    spermission.prov_native_value,
    spermission.prov_unique_driver_id,
    spermission.provisionable,
    spermission.risk,
    spermission.type,
    spermission.unique_bound_by_id,
    spermission.unique_permission_id,
    spermission.value,
    spermission.value_type,
    spermission.application,
    spermission.base_application,
    spermission.collected_entity,
    spermission.data_collection,
    spermission.effective_entity,
    spermission.sversion,
    spermission.auto_generated,
    spermission.prov_unique_permission_id,
    listagg(TO_CHAR(auth_by.brole_name), ' | ') WITHIN GROUP (ORDER BY auth_by.brole_name) authorized_by 
 FROM spermission 
 LEFT JOIN (SELECT brole.brole_name, brole.unique_item_id 
        FROM (SELECT business_role_id, unique_item_id,(SELECT DISTINCT brole.name FROM business_role brole WHERE br_incl_item.business_role_id = brole.id AND brole.approval_state = 'PUBLISHED') brole_name
            FROM business_role_incl_item br_incl_item) brole, spermission       
        WHERE brole.unique_item_id = spermission.unique_permission_id AND brole.brole_name IS NOT NULL) auth_by ON auth_by.unique_item_id = spermission.unique_permission_id
 WHERE spermission.deleted = 0 AND spermission.effective = 1
 GROUP BY spermission.id,
    spermission.account_grant,
    spermission.assignable,
    spermission.authoritative,
    to_char(spermission.bound_by_id),
    spermission.boundable,
    spermission.cost,
    spermission.deleted,
    spermission.description,
    spermission.display_name,
    spermission.driver_id,
    spermission.effective,
    spermission.exclude_from_catalog,
    spermission.is_curated,
    spermission.logical_id,
    spermission.merged,
    spermission.name,
    spermission.not_reviewable,
    spermission.owner,
    to_char(spermission.permission_id),
    spermission.prov_attribute,
    spermission.prov_by_unique_permission_id,
    spermission.prov_native_value,
    spermission.prov_unique_driver_id,
    spermission.provisionable,
    spermission.risk,
    spermission.type,
    spermission.unique_bound_by_id,
    spermission.unique_permission_id,
    spermission.value,
    spermission.value_type,
    spermission.application,
    spermission.base_application,
    spermission.collected_entity,
    spermission.data_collection,
    spermission.effective_entity,
    spermission.sversion,
    spermission.auto_generated,
    spermission.prov_unique_permission_id;

	GRANT SELECT ON arops.SPERMISSION_V TO arrptuser;
	CREATE OR REPLACE PUBLIC SYNONYM SPERMISSION_V for arops.SPERMISSION_V;